// Load dts shapes and merge animations
datablock TSShapeConstructor(DragonflyHoleBotDts)
{
	baseShape  = "./Dragon_Fly8.dts";
	sequence0  = "./dgnf_root.dsq root";

	sequence1  = "./dgnf_run.dsq run";
	sequence2  = "./dgnf_run.dsq walk";
	sequence3  = "./dgnf_back.dsq back";
	sequence4  = "./dgnf_side.dsq side";

	sequence5  = "./dgnf_root.dsq crouch";
	sequence6  = "./dgnf_run.dsq crouchRun";
	sequence7  = "./dgnf_back.dsq crouchBack";
	sequence8  = "./dgnf_side.dsq crouchSide";

	sequence9  = "./dgnf_root.dsq look";
	sequence10 = "./dgnf_root.dsq headside";
	sequence11 = "./dgnf_root.dsq headUp";

	sequence12 = "./dgnf_jump_fly.dsq jump";
	sequence13 = "./dgnf_jump_fly.dsq standjump";
	sequence14 = "./dgnf_fly_LOOP.dsq fall";
	sequence15 = "./dgnf_root.dsq land";

	sequence16 = "./dgnf_attack.dsq armAttack";
	sequence17 = "./dgnf_root.dsq armReadyLeft";
	sequence18 = "./dgnf_root.dsq armReadyRight";
	sequence19 = "./dgnf_root.dsq armReadyBoth";
	sequence20 = "./dgnf_root.dsq spearready";  
	sequence21 = "./dgnf_attack.dsq spearThrow";

	sequence22 = "./dgnf_root.dsq talk";  

	sequence23 = "./dgnf_death.dsq death1"; 
	
	sequence24 = "./dgnf_attack.dsq shiftUp";
	sequence25 = "./dgnf_root.dsq shiftDown";
	sequence26 = "./dgnf_attack.dsq shiftAway";
	sequence27 = "./dgnf_root.dsq shiftTo";
	sequence28 = "./dgnf_root.dsq shiftLeft";
	sequence29 = "./dgnf_root.dsq shiftRight";
	sequence30 = "./dgnf_root.dsq rotCW";
	sequence31 = "./dgnf_root.dsq rotCCW";

	sequence32 = "./dgnf_root.dsq undo";
	sequence33 = "./dgnf_attack.dsq plant";

	sequence34 = "./dgnf_pose.dsq sit";

	sequence35 = "./dgnf_attack.dsq wrench";

   sequence36 = "./dgnf_attack.dsq activate";
   sequence37 = "./dgnf_attack.dsq activate2";

   sequence38 = "./dgnf_attack.dsq leftrecoil";
   
//   sequence39 = "./dgnf_pinchReady.dsq stingReady";	//stingReady so it will work with scorpion sting weapons
   sequence39 = "./dgnf_fly.dsq Fly";
};    

datablock fxDTSBrickData (BrickDragonflyBot_HoleSpawnData)
{
	brickFile = "Add-ons/Bot_Hole/6xSpawn.blb";
	category = "Special";
	subCategory = "Holes";
	uiName = "Dragonfly Hole";
	iconName = "Add-Ons/Bot_BugMod2/icon_dragonfly";

	bricktype = 2;
	cancover = 0;
	orientationfix = 1;
	indestructable = 1;

	isBotHole = 1;
	holeBot = "DragonflyHoleBot";
};

datablock PlayerData(DragonflyHoleBot : PlayerStandardArmor)
{
	//category = "Vehicles";
	shapeFile = "./Dragon_Fly8.dts";
	minJetEnergy = 0;
	jetEnergyDrain = 0;
	canJet = 0;
	maxItems   = 10;	//total number of bricks you can carry
	maxWeapons = 5;		//this will be controlled by mini-game code
	maxTools = 5;
	runforce = 120 * 90;		//100 * 90
	maxForwardSpeed = 11;
	maxBackwardSpeed = 11;
	maxSideSpeed = 11;
	maxForwardCrouchSpeed = 10;
	maxBackwardCrouchSpeed = 9;
	maxSideCrouchSpeed = 7;
	jumpForce = 10 * 90; //8.3 * 90;
    jumpDelay = 0;
	//jumpsound = "ArmorJumpSound";
	cameradefaultFOV = 90;
	cameraMaxFov = 120;
	cameraMinFov = 10;
	//minlookangle = -1;
	//maxlookangle = -1;
	minlookangle = -1.5708;
	maxlookangle = 1.5708;
	uiName = "B2 Dragonfly";
	rideable = true;
	canRide = false;

//	attackpower = 25;
//	BrickDestroyMaxVolume = 250;
//	BrickMaxJumpHeight = 3;
//	BrickKillRadius = 2;
//	FollowAnim = "root";
//	randomwalk = 1;
//	aimatplayer = 1;
//	SpecialAttack = 0;
//	NoBloodyHands = 1;
//	DoNotZombify = 1;
//	chance = 50;
//	SearchRadius = 50;
//	ZombieTeam = "Dragonflies";

	maxDamage = 150;	//250
	jumpsound = "";
	paintable = true;

	boundingBox				= vectorScale("2.8 2.8 1.2", 4); //"2.5 2.5 2.4";
    crouchBoundingBox		= vectorScale("2.8 2.8 1.2", 4); //"2.5 2.5 2.4";
    proneBoundingBox		= vectorScale("2.8 2.8 1.2", 4); //"2.5 2.5 2.4";
	mass = 90;
	drag = 0.04;
    minImpactSpeed = 160;
	speedDamageScale = 0.5;    
	numMountPoints = 0;
	airControl		= 1;
//	maxStepHeight = 0.5;

//	isLargeEnemy = 1;

	maxEnergy = 100;
	rechargeRate = 1;
	showEnergyBar = true;

	useCustomPainEffects = true;
	PainHighImage = "PainHighImage";
	PainMidImage  = "PainMidImage";
	PainLowImage  = "PainLowImage";
	PainSound           = "";
	DeathSound          = "";

	//Hole Attributes

	isHoleBot = 1;

	//Spawning option
	hSpawnTooClose = 0;//Doesn't spawn when player is too close and can see it
	  hSpawnTCRange = 8;//above range, set in brick units
	hSpawnClose = 0;//Only spawn when close to a player, can be used with above function as long as hSCRange is higher than hSpawnTCRange
	  hSpawnCRange = 32;//above range, set in brick units

	hType = Dragonfly; //Enemy,Friendly, Neutral
	  hNeutralAttackChance = 100; //0 to 100, Chance that this type will attack neutral bots, ie horses/vehicles/civilians
	//can have unique types, nazis will attack zombies but nazis will not attack other bots labeled nazi
	hName = "Dragonfly";//cannot contain spaces
	hTickRate = 2500;	//3000
	
	//Wander Options
	hWander = 1;//Enables random walking
	  hSmoothWander = 1;//This is in addition to regular wander, makes them walk a bit longer, and a bit smoother
	  hReturnToSpawn = 1;//Returns to spawn when too far
	  hSpawnDist = 48;//Defines the distance bot can travel away from spawnbrick
	  hGridWander = 0;//Locks the bot to a grid, overwrites other settings
	
	//Searching options
	hSearch = 1;//Search for Players
	  hSearchRadius = 128;//in brick units
	  hSight = 1;//Require bot to see player before pursuing
	  hStrafe = 1;//Randomly strafe while following player
	hSearchFOV = 0;//if enabled disables normal hSearch
	  hFOVRange = 0.7; // determines the angle we can see the player at, 0.7 is about normal fov for players, if 0 we can see all in front, if 1 we could only see someone perfectly ahead, can be negative
	  // hFOVRadius = 6; // no longer used, we now use searchRadius
	  hHearing = 1;//If it hears a player it'll look in the direction of the sound

	  hAlertOtherBots = 0;//Alerts other bots when he sees a player, or gets attacked

	//Attack Options
	hMelee = 1;//Melee
	  hAttackDamage = 15;//Melee Damage
	hShoot = 1;
	  hWep = "DflyPounceItem";
	  hShootTimes = 3;//Number of times the bot will shoot between each tick
	  hMaxShootRange = 256;//The range in which the bot will shoot the player	//256
	  hAvoidCloseRange = 0;//
		hTooCloseRange = 7;//in brick units

	//Misc options
	hActivateDirection = 0; // 0 1 2, determines the direction you have to face the bot to activate him, both, front back
	hMoveSlowdown = 0; // bool, determines wether the bot will slow down when following enemies
	hAvoidObstacles = 1;
	hSuperStacker = 0;//When enabled makes the bots stack a bit better, in other words, jumping on each others heads to get to a player
	hSpazJump = 1;//Makes bot jump when the user their following is higher than them
	hAFKOmeter = 1;//Determines how often the bot will wander or do other idle actions, higher it is the less often he does things

	hIdle = 1;// Enables use of idle actions, actions which are done when the bot is not doing anything else
	  hIdleAnimation = 0;//Plays random animations/emotes, sit, click, love/hate/etc
	  hIdleLookAtOthers = 1;//Randomly looks at other players/bots when not doing anything else
	    hIdleSpam = 0;//Makes them spam click and spam hammer/spraycan
	  hSpasticLook = 1;//Makes them look around their environment a bit more.
	hEmote = 0;

};
function DragonflyHoleBot::onAdd(%this,%obj)
{
	armor::onAdd(%this,%obj);

	%color = getRandom(0,4);
	if(%color == 0)
		%obj.chestColor = "1.0 0.1 0.0 1";
	if(%color == 1)
		%obj.chestColor = "0.6 0.1 0.0 1";
	if(%color == 2)
		%obj.chestColor = "1.0 0.26 0.0 1";
	if(%color == 3)
		%obj.chestColor = "0.163 0.373 0.629 1";
	if(%color == 4)
		%obj.chestColor = "1.0 0.6 0.1 1";

	GameConnection::ApplyBodyParts(%obj);
	GameConnection::ApplyBodyColors(%obj);

//	schedule(15,0,recolorbug,%obj);
}
function DragonflyHoleBot::onTrigger(%this, %obj, %trig, %press) {
	if(%trig == 2 && %press && getsimtime() >= %obj.lastjump+200)
	{
		//flap code goes here. What follows is a recreation of the standard jump on a standard armor MINUS a check to be sure we're touching the ground - flying is possible with this.

		//pretty sure it doesn't play a sound either, because, again, I didn't need it for my purposes.
		%obj.forbidJump = true;
		%obj.addVelocity("0 0 8");	//7
		%obj.playThread(0, "Fly"); //animation
//		ServerPlay3D(AirDragonJumpSound, %obj.getPosition());
		%obj.lastjump = getsimtime();
	}
	else Parent::onTrigger(%this, %obj, %trig, %press);
}

function allowJump(%obj) {
	if(!isObject(%obj)) 
		return;
	%obj.forbidJump = false;
}
