//NEW
$mantyCloakLoopDelay = 100; //Useful for server owners who think the manty loops are lagging them.
$mantyCloakDelay = 1000; //Useful for server owners who wish to customize the passive cloaking ability. (Maybe interesting for RTB pref?)	//1500
//END-NEW, REPLACE PREVIOUS GLOBAL VARIABLES


// Load dts shapes and merge animations
datablock TSShapeConstructor(MantisHoleBotDts)
{
	baseShape  = "./praying_mantis2.dts";
	sequence0  = "./mts_root.dsq root";

	sequence1  = "./mts_run.dsq run";
	sequence2  = "./mts_run.dsq walk";
	sequence3  = "./mts_back.dsq back";
	sequence4  = "./mts_side.dsq side";

	sequence5  = "./mts_crouch.dsq crouch";
	sequence6  = "./mts_crouchMove.dsq crouchRun";
	sequence7  = "./mts_crouchBack.dsq crouchBack";
	sequence8  = "./mts_crouchSide.dsq crouchSide";

	sequence9  = "./mts_look.dsq look";
	sequence10 = "./mts_headside.dsq headside";
	sequence11 = "./mts_root.dsq headUp";

	sequence12 = "./mts_jump2.dsq jump";
	sequence13 = "./mts_jump2.dsq standjump";
	sequence14 = "./mts_fly_loop.dsq fall";
	sequence15 = "./mts_root.dsq land";

	sequence16 = "./mts_root.dsq armAttack";
	sequence17 = "./mts_root.dsq armReadyLeft";
	sequence18 = "./mts_root.dsq armReadyRight";
	sequence19 = "./mts_root.dsq armReadyBoth";
	sequence20 = "./mts_root.dsq spearready";  
	sequence21 = "./mts_grab.dsq spearThrow";

	sequence22 = "./mts_eat.dsq talk";  

	sequence23 = "./mts_death.dsq death1"; 
	
	sequence24 = "./mts_root.dsq shiftUp";
	sequence25 = "./mts_root.dsq shiftDown";
	sequence26 = "./mts_root.dsq shiftAway";
	sequence27 = "./mts_root.dsq shiftTo";
	sequence28 = "./mts_slash_left.dsq shiftLeft";
	sequence29 = "./mts_slash_right.dsq shiftRight";
	sequence30 = "./mts_root.dsq rotCW";
	sequence31 = "./mts_root.dsq rotCCW";

	sequence32 = "./mts_root.dsq undo";
	sequence33 = "./mts_root.dsq plant";

	sequence34 = "./mts_fightingStance.dsq sit";

	sequence35 = "./mts_root.dsq wrench";

   sequence36 = "./mts_slash_right.dsq activate";
   sequence37 = "./mts_slash_right.dsq activate2";

   sequence38 = "./mts_root.dsq leftrecoil";
   
   sequence39 = "./mts_root.dsq stingReady";	//stingReady so it will work with scorpion sting weapons
   sequence40 = "./mts_fly.dsq Fly";
};

datablock fxDTSBrickData (BrickMantisBot_HoleSpawnData)
{
	brickFile = "Add-ons/Bot_Hole/6xSpawn.blb";
	category = "Special";
	subCategory = "Holes";
	uiName = "Mantis Hole";
	iconName = "Add-Ons/Bot_BugMod2/icon_mantis";

	bricktype = 2;
	cancover = 0;
	orientationfix = 1;
	indestructable = 1;

	isBotHole = 1;
	holeBot = "MantisHoleBot";
};

datablock PlayerData(MantisHoleBot : PlayerStandardArmor)
{
	//category = "Vehicles";
	shapeFile = "./praying_mantis2.dts";
	minJetEnergy = 0;
	jetEnergyDrain = 0;
	canJet = 0;
	maxItems   = 10;	//total number of bricks you can carry
	maxWeapons = 5;		//this will be controlled by mini-game code
	maxTools = 5;
	runforce = 50 * 90;
	maxForwardSpeed = 9.5;	//9
	maxBackwardSpeed = 8.5;	//8
	maxSideSpeed = 8.5;		//8
	maxForwardCrouchSpeed = 8;
	maxBackwardCrouchSpeed = 7;
	maxSideCrouchSpeed = 7;
	jumpForce = 10 * 90; //11 * 90;
    jumpDelay = 0;
	attackpower = 45;	//25
	//jumpsound = "ZombieJumpSound";
	cameradefaultFOV = 90;
	cameraMaxFov = 120;
	cameraMinFov = 10;
	//minlookangle = -1;
	//maxlookangle = -1;
	minlookangle = -1.5708;
	maxlookangle = 1.5708;
//	BrickDestroyMaxVolume = 250;
//	BrickMaxJumpHeight = 3;
	uiName = "B2 Praying Mantis";
	rideable = true;
	canRide = false;
//	BrickKillRadius = 2;
//	FollowAnim = "root";
//	randomwalk = 1;
//	aimatplayer = 1;
//	SpecialAttack = 0;
//	NoBloodyHands = 1;
//	DoNotZombify = 1;
//	chance = 50;
//	SearchRadius = 50;
//	ZombieTeam = "Mantis";
	maxDamage = 800;	//800
	jumpsound = "";
	paintable = true;

	boundingBox				= vectorScale("2.8 2.8 4.1", 4); //"2.5 2.5 2.4";
    crouchBoundingBox		= vectorScale("2.8 2.8 1.9", 4); //"2.5 2.5 2.4";
    proneBoundingBox		= vectorScale("2.8 2.8 1.9", 4); //"2.5 2.5 2.4";
//	mass = 50;
    minImpactSpeed = 160;
	speedDamageScale = 0.5;    
	numMountPoints = 0;
	airControl		= 0.45;
	maxStepHeight = 1.4;

//	isLargeEnemy = 1;

	useCustomPainEffects = true;
	PainHighImage = "PainHighImage";
	PainMidImage  = "PainMidImage";
	PainLowImage  = "PainLowImage";
	PainSound           = "";
	DeathSound          = "";

	//Hole Attributes

	isHoleBot = 1;

	//Spawning option
	hSpawnTooClose = 0;//Doesn't spawn when player is too close and can see it
	  hSpawnTCRange = 8;//above range, set in brick units
	hSpawnClose = 0;//Only spawn when close to a player, can be used with above function as long as hSCRange is higher than hSpawnTCRange
	  hSpawnCRange = 32;//above range, set in brick units

	hType = Mantis; //Enemy,Friendly, Neutral
	  hNeutralAttackChance = 100; //0 to 100, Chance that this type will attack neutral bots, ie horses/vehicles/civilians
	//can have unique types, nazis will attack zombies but nazis will not attack other bots labeled nazi
	hName = "Mantis";//cannot contain spaces
	hTickRate = 3000;
	
	//Wander Options
	hWander = 1;//Enables random walking
	  hSmoothWander = 1;//This is in addition to regular wander, makes them walk a bit longer, and a bit smoother
	  hReturnToSpawn = 1;//Returns to spawn when too far
	  hSpawnDist = 10;//Defines the distance bot can travel away from spawnbrick
	  hGridWander = 0;//Locks the bot to a grid, overwrites other settings
	
	//Searching options
	hSearch = 1;//Search for Players
	  hSearchRadius = 32;//in brick units
	  hSight = 1;//Require bot to see player before pursuing
	  hStrafe = 0;//Randomly strafe while following player
	hSearchFOV = 0;//if enabled disables normal hSearch
	  hFOVRange = 0.7; // determines the angle we can see the player at, 0.7 is about normal fov for players, if 0 we can see all in front, if 1 we could only see someone perfectly ahead, can be negative
	  // hFOVRadius = 6; // no longer used, we now use searchRadius
	  hHearing = 1;//If it hears a player it'll look in the direction of the sound

	  hAlertOtherBots = 0;//Alerts other bots when he sees a player, or gets attacked

	//Attack Options
	hMelee = 0;//Melee
	  hAttackDamage = 10;//Melee Damage
	hShoot = 1;
	  hWep = "MantisSlashItem";
	  hShootTimes = 3;//Number of times the bot will shoot between each tick
	  hMaxShootRange = 32;//The range in which the bot will shoot the player	//256
	  hAvoidCloseRange = 1;//
		hTooCloseRange = 2;//in brick units

	//Misc options
	hActivateDirection = 0; // 0 1 2, determines the direction you have to face the bot to activate him, both, front back
	hMoveSlowdown = 0; // bool, determines wether the bot will slow down when following enemies
	hAvoidObstacles = 1;
	hSuperStacker = 0;//When enabled makes the bots stack a bit better, in other words, jumping on each others heads to get to a player
	hSpazJump = 1;//Makes bot jump when the user their following is higher than them
	hAFKOmeter = 5;//Determines how often the bot will wander or do other idle actions, higher it is the less often he does things

	hIdle = 1;// Enables use of idle actions, actions which are done when the bot is not doing anything else
	  hIdleAnimation = 0;//Plays random animations/emotes, sit, click, love/hate/etc
	  hIdleLookAtOthers = 1;//Randomly looks at other players/bots when not doing anything else
	    hIdleSpam = 0;//Makes them spam click and spam hammer/spraycan
	  hSpasticLook = 1;//Makes them look around their environment a bit more.
	hEmote = 0;

};
function MantisHoleBot::ondisabled(%this,%obj)
{
	parent::ondisabled(%this,%obj);
	//Cloak thingy
	if (isEventPending(%player.mantyCloakSched)) { cancel(%player.mantyCloakSched); }
}
function MantisHoleBot::onAdd(%this,%obj)
{
	armor::onAdd(%this,%obj);

	%color = getRandom(0,4);
	if(%color == 0)
		%obj.chestColor = "0.464 0.731 0.273 1";
	if(%color == 1)
		%obj.chestColor = "0.165 0.480 0.211 1";
	if(%color == 2)
		%obj.chestColor = "0.349 0.240 0.090 1";
	if(%color == 3)
		%obj.chestColor = "0.391 0.442 0.181 1";
	if(%color == 4)
		%obj.chestColor = "0.046 0.209 0.021 1";

	GameConnection::ApplyBodyParts(%obj);
	GameConnection::ApplyBodyColors(%obj);

//	schedule(15,0,recolorbug,%obj);
}
function MantisHoleBot::onTrigger(%this, %obj, %trig, %press) {
	
	if(%trig == 2)
	{
		
		if (isEventPending(%obj.mantyCloakSched)) { cancel(%obj.mantyCloakSched); }
		%obj.noCloak = %press;
		if(%press && getsimtime() >= %obj.lastjump+200)
		{
			//flap code goes here. What follows is a recreation of the standard jump on a standard armor MINUS a check to be sure we're touching the ground - flying is possible with this.

			//pretty sure it doesn't play a sound either, because, again, I didn't need it for my purposes.
			%obj.forbidJump = true;
			%obj.addVelocity("0 0 4.8");	//5
			%obj.playThread(0, "Fly"); //animation
			//ServerPlay3D(AirDragonJumpSound, %obj.getPosition());
			%obj.lastjump = getsimtime();
			if (%obj.isCloaked) {  %obj.cloakEnd(%obj.cloakTime); }
			return;
		
		} else if(!%press) {
			
			if (%obj.mantyCloak) { %obj.mantyCloakSched = %obj.schedule($mantyCloakDelay, checkMantyCloak); }
			%obj.mantyCloakPos = %obj.getPosition();
			%obj.mantyCloakLastMove = getSimTime();
			return;
			
		}
		
	} else if (%trig == 0) {
		
		if (isEventPending(%obj.mantyCloakSched)) { cancel(%obj.mantyCloakSched); }
		
		if (!%press) {
			
			if (%obj.mantyCloak) { %obj.mantyCloakSched = %obj.schedule($mantyCloakDelay, checkMantyCloak); }
			%obj.mantyCloakLastMove = getSimTime();
			%obj.mantyCloakPos = %obj.getPosition();
			
		}
		
	}
	Parent::onTrigger(%this, %obj, %trig, %press);
}

function allowJump(%obj) {
	if(!isObject(%obj)) 
		return;
	%obj.forbidJump = false;
}

//Mantis Passive Cloak thingymajigies
function MantisHoleBot::onNewDatablock (%this, %player) {
	
	Parent::onNewDatablock(%this, %player);
	%player.cloakTime = 1000;
	%player.cloakAllowToolEquip = 1;
	%player.cloakAllowToolUse = 0;
	%player.cloakAllowEmote = 0;
	%player.cloakAllowCapture = 0;
	%player.cloakAllowJump = 0;
	
	if (isObject(%player.light)) {
		
		%player.light.delete();
		%player.light = 0;
		
	}
	
	if (isObject(%player.client)) {
		
		%player.client.bottomPrint("Passive Cloak offline, press your Light Key to toggle.",3);
		
	}
	
}

function MantisHoleBot::onCloakEnded(%player) {
	
	if (isEventPending(%player.mantyCloakSched)) { cancel(%player.mantyCloakSched); }
	if (%player.mantyCloak) { %player.mantyCloakSched = %player.schedule($mantyCloakDelay, checkMantyCloak); }
	%player.mantyCloakPos = %player.getPosition();
	%player.mantyCloakLastMove = getSimTime();
	
	
}

function Player::checkMantyCloak (%player) {
	
	if (%player.mantyCloak) {

		if (%player.getPosition() == %player.mantyCloakPos) {
			
			//Player didn't move since last measure, maybe trying to cloak.
			if (!%player.isCloaked && !%player.isCloaking) {
				
				//Player still has to cloak.
				if (getSimTime() - %player.mantyCloakLastMove >= $mantyCloakDelay) {
					
					//The player passed the time requirement
					%player.cloakStart(%player.cloakTime);
					%player.mantyCloakSched = %player.schedule($mantyCloakLoopDelay, checkMantyCloak);
					
				} else {
					
					//Player hasn't been standing still long enough.
					%player.mantyCloakSched = %player.schedule(($mantyCloakDelay - %player.mantyCloakLastMove), checkMantyCloak); //Schedule to when he actually will meet the requirement, if he didn't move by then.
					
				}
				
			} else {
			
				//Already cloaked and standing still... Continue.
				%player.mantyCloakSched = %player.schedule($mantyCloakLoopDelay, checkMantyCloak);
			
			}
			
		} else {
			
			//Player has moved since last check. :C
			if (%player.isCloaked) {
				
				%player.cloakEnd(%player.cloakTime);
				
			}
			%player.mantyCloakPos = %player.getPosition();
			%player.mantyCloakLastMove = getSimTime();
			%player.mantyCloakSched = %player.schedule($mantyCloakLoopDelay, checkMantyCloak);
			
		}
	
	}
	
}

//Package magic
if (isPackage(MantyCode)) {
	
	deactivatePackage(MantyCode);	//De-activates package with the same name if there is any. Safety measure.
}

package MantyCode {

	function servercmdLight (%client) {
		
		%player = %client.player;
		if (isObject(%player)) {
			
			if (%player.getDatablock().getName() $= "MantisHoleBot") {
				
				if (isEventPending(%player.mantyCloakSched)) { cancel(%player.mantyCloakSched); }
				if (%player.mantyCloak) {
					
					if (%player.isCloaked) {
						
						%player.cloakEnd(%player.cloakTime);
						
					}
					%player.mantyCloak = 0;
					%player.noCloak = 1;
					%client.bottomPrint("Passive Cloak offline, press your Light Key to toggle.",3);
					
				} else {
					
					%player.mantyCloak = 1;
					%player.noCloak = 0;
					%player.mantyCloakPos = %player.getPosition();
					%player.mantyCloakLastMove = getSimTime();
					%player.mantyCloakSched = %player.schedule($mantyCloakDelay, checkMantyCloak);
					%client.bottomPrint("Passive Cloak online, press your Light Key to toggle.",3);
					
				}
				return;
				
			}
			
		}
		
		Parent::servercmdLight(%client);
		
	}

}; 
activatePackage(MantyCode);
