//Weapon_FF_Bash.cs

//effects
//datablock ParticleData(DflyPounceHitParticle)
//{
//	dragCoefficient      = 1.5;
//	gravityCoefficient   = 0.5;
//	inheritedVelFactor   = 0.2;
//	constantAcceleration = 0.0;
//	spinRandomMin 	     = -90;
//	spinRandomMax 		= 90;
//	lifetimeMS           = 180;
//	lifetimeVarianceMS   = 100;
//	textureName          = "base/data/particles/star1";
//	colors[0]     = "0.7 1.0 0.65 0.9";
//	colors[1]     = "0.3 0.7 0.3 0.1";
//	sizes[0]      = 0.3;
//	sizes[1]      = 0.1;
//	times[0]	  = 0.0;
//	times[1]	  = 1.0;

//	useInvAlpha = true;
//};

//datablock ParticleEmitterData(DflyPounceHitEmitter)
//{
//   ejectionPeriodMS = 10;
//   periodVarianceMS = 1;
//   ejectionVelocity = 4.5;
//   velocityVariance = 1.0;
//   ejectionOffset   = 1;
//   thetaMin         = 0;
//   thetaMax         = 180;
//   phiReferenceVel  = 0;
//   phiVariance      = 360;
//   overrideAdvance = false;
//   particles = "DflyPounceHitParticle";

//   uiName = "Cicada Bash";
//};

datablock ExplosionData(DflyPounceExplosion)
{
//   explosionShape = "base/data/shapes/empty.dts";
   lifeTimeMS = 150;

   soundProfile = Bug2MeleeAttacksound;

   particleEmitter = FireflyBashHitEmitter;
   particleDensity = 15;
   particleRadius = 0.1;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "2.0 2.0 1.0";
   camShakeAmp = "20.0 20.0 3.0";
   camShakeDuration = 0.15;
   camShakeRadius = 4.0;
	
	impulseRadius = 2;
	impulseForce = 200;

	damageRadius = 0.01;
	radiusDamage = 0.01;
};

//projectile
//AddDamageType("Mitebite",   '<bitmap:add-ons/Weapon_Sword/CI_sword> %1',    '%2 <bitmap:add-ons/Weapon_Sword/CI_sword> %1',0.75,1);
datablock ProjectileData(DflyPounceProjectile) // : BugBitePtojectile)
{
   directDamage        = 45;	//30
//   directDamageType  = $DamageType::Mitebite;
//   radiusDamageType  = $DamageType::Mitebite;
   explosion           = DflyPounceExplosion;

	impactImpulse	   = 300;
	verticalImpulse	   = 300;

	brickExplosionRadius = 0;
	brickExplosionImpact = true; //destroy a brick if we hit it directly?
	brickExplosionForce  = 20;
	brickExplosionMaxVolume = 200;
	brickExplosionMaxVolumeFloating = 200;


   muzzleVelocity      = 80;	//60
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 100;
   fadeDelay           = 70;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
//   lightRadius = 3.0;
//   lightColor  = "0 0 0.5";

   uiName = "Firefly Pounce";
};


//////////
// item //
//////////
datablock ItemData(DflyPounceItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	// Basic Item Properties
	shapeFile = "base/data/shapes/empty.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = false;

	//gui stuff
	uiName = "D.fly Pounce";
	iconName = "./Icon_DragonflyBash";
//	doColorShift = false;
//	colorShiftColor = "0.471 0.471 0.471 1.000";

	// Dynamic properties defined by the scripts
	image = DflyPounceImage;
	canDrop = false;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(DflyPounceImage)
{
   // Basic Item properties
	shapeFile = "base/data/shapes/empty.dts";
	emap = false;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   eyeOffset = "0 0 0";

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = DflyPounceProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = true;
   doRetraction = false;
   //raise your arm up or not
   armReady = false;

	minShotTime = 1100;

   //casing = " ";
//   doColorShift = false;
//   colorShiftColor = "0.471 0.471 0.471 1.000";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.2;
	stateTransitionOnTimeout[0]      = "Ready";
//	stateSound[0]                    = swordDrawSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "PreFire";
	stateAllowImageChange[1]         = true;
	
	stateName[2]                    = "PreFire";
	stateTransitionOnTimeout[2]     = "Fire";
	stateTimeoutValue[2]            = 0.05;
	stateFire[2]                    = false;
	stateAllowImageChange[2]        = false;
//	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onPreFire";
	stateWaitForTimeout[2]		= true;

	stateName[3]                    = "Fire";
	stateTransitionOnTimeout[3]     = "Recharge";
	stateTimeoutValue[3]            = 0.1;
	stateFire[3]                    = true;
	stateAllowImageChange[3]        = false;
//	stateSequence[3]                = "Fire";
	stateScript[3]                  = "onFire";
	stateWaitForTimeout[3]		= true;

//	stateName[4]			= "CheckFire";
//	stateTransitionOnTriggerUp[4]	= "StopFire";
//	stateTransitionOnTriggerDown[4]	= "Fire";

	
	stateName[4]                    = "Recharge";
	stateTransitionOnTimeout[4]     = "Ready";
	stateTimeoutValue[4]            = 1.0;
	stateAllowImageChange[4]        = true;
	stateWaitForTimeout[4]			= true;
//	stateSequence[4]                = "StopFire";
//	stateScript[4]                  = "onStopFire";

};


function DflyPounceImage::onPreFire(%this, %obj, %slot)
{

	if((%obj.lastFireTime2+%this.minShotTime) > getSimTime())
		return;
	%obj.lastFireTime2 = getSimTime();

	%fvec = %obj.getForwardVector();
	%fX = getWord(%fvec,0);
	%fY = getWord(%fvec,1);

	%evec = %obj.getEyeVector();
	%eX = getWord(%evec,0);
	%eY = getWord(%evec,1);
	%eZ = getWord(%evec,2);

	%eXY = mSqrt(%eX*%eX+%eY*%eY);

	%aimVec = %fX*%eXY SPC %fY*%eXY SPC %eZ;

	%obj.setVelocity(VectorAdd(%obj.getVelocity(),VectorScale(%aimVec,"15")));	//22

//	if(%obj.getDamagePercent() < 1.0)
	%obj.playthread(2, plant);
}

function DflyPounceImage::onFire(%this, %obj, %slot)
{
//	if((%obj.lastFireTime+%this.minShotTime) > getSimTime())
//		return;
//	%obj.lastFireTime = getSimTime();
	Parent::onFire(%this,%obj,%slot);

//	if(%obj.getDamagePercent() < 1.0)
//		%obj.playthread(2, plant);
}
