//Weapon_FF_Flash.cs


datablock ExplosionData(FireFlyFlashExplosion)
{
//   explosionShape = "base/data/shapes/empty.dts";
   lifeTimeMS = 200;

//   soundProfile = "";

   particleEmitter = FireFlyFlashEmitter;
   particleDensity = 15;
   particleRadius = 0.05;

//	emitter[0] = FireFlyFlashEmitter;

	debris = FireFlyFlashDebris;
	debrisNum = 12;		//15
	debrisNumVariance = 3;
	debrisPhiMin = 0;
	debrisPhiMax = 360;
	debrisThetaMin = 0;
	debrisThetaMax = 180;
	debrisVelocity = 50;
	debrisVelocityVariance = 10;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "18.0 18.0 15.0";
   camShakeAmp = "0.5 0.5 0.1";
   camShakeDuration = 0.2;
   camShakeRadius = 5.0;

	// Dynamic light
	lightStartRadius = 12;
	lightEndRadius = 10;
	lightStartColor = "0.9 1 0.9 1";
	lightEndColor = "0.5 1 0.5 0";

	impulseRadius = 0.01;
	impulseForce = 0.01;

	damageRadius = 1;
	radiusDamage = 0;
};

//projectile
//AddDamageType("Mitebite",   '<bitmap:add-ons/Weapon_Sword/CI_sword> %1',    '%2 <bitmap:add-ons/Weapon_Sword/CI_sword> %1',0.75,1);
datablock ProjectileData(FireFlyFlashProjectile) // : BugBitePtojectile)
{
   directDamage        = 0;
//   directDamageType  = $DamageType::Mitebite;
//   radiusDamageType  = $DamageType::Mitebite;
	explosion           = FireFlyFlashExplosion;
	explodeOnDeath = 1;

	impactImpulse	   = 0;
	verticalImpulse	   = 0;

	brickExplosionRadius = 0;
	brickExplosionImpact = false; //destroy a brick if we hit it directly?
	brickExplosionForce  = 20;
	brickExplosionMaxVolume = 200;
	brickExplosionMaxVolumeFloating = 200;

	muzzleVelocity      = 1;
	velInheritFactor    = 1;

	armingDelay         = 0;
	lifetime            = 100;
	fadeDelay           = 1;
	bounceElasticity    = 0;
	bounceFriction      = 0;
	isBallistic         = false;
	gravityMod = 0.0;


   muzzleVelocity      = 1;
   velInheritFactor    = 1;

   hasLight    = false;
//   lightRadius = 3.0;
//   lightColor  = "0 0 0.5";

   uiName = "Firefly Flash";
};


//////////
// item //
//////////
datablock ItemData(FireFlyFlashItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	// Basic Item Properties
	shapeFile = "base/data/shapes/empty.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = false;

	//gui stuff
	uiName = "Firefly Flash";
	iconName = "./Icon_FireflyFlash";
//	doColorShift = false;
//	colorShiftColor = "0.471 0.471 0.471 1.000";

	// Dynamic properties defined by the scripts
	image = FireFlyFlashImage;
	canDrop = false;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(FireFlyFlashImage)
{
   // Basic Item properties
	shapeFile = "base/data/shapes/empty.dts";
	emap = false;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   eyeOffset = "0 0 0";

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = FireFlyFlashItem;
   ammo = " ";
   projectile = FireFlyFlashProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = false;
   doRetraction = false;
   //raise your arm up or not
   armReady = false;

   //casing = " ";
//   doColorShift = false;
//   colorShiftColor = "0.471 0.471 0.471 1.000";

	minShotTime = 5000;

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.1;
	stateTransitionOnTimeout[0]      = "Ready";
//	stateSound[0]                    = swordDrawSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "PreFire";
	stateAllowImageChange[1]         = true;

	stateName[2]                    = "PreFire";
	stateTransitionOnTimeout[2]     = "Fire";
	stateTimeoutValue[2]            = 0.07;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
//	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onPreFire";
	stateWaitForTimeout[2]		= true;

	stateName[3]                    = "Fire";
	stateTransitionOnTimeout[3]     = "Recharge";
	stateTimeoutValue[3]            = 0.1;
	stateFire[3]                    = true;
	stateAllowImageChange[3]        = false;
//	stateSequence[3]                = "Fire";
	stateScript[3]                  = "onFire";
	stateWaitForTimeout[3]		= true;

//	stateName[4]			= "CheckFire";
//	stateTransitionOnTriggerUp[4]	= "StopFire";
//	stateTransitionOnTriggerDown[4]	= "Fire";
	
	stateName[4]                    = "Recharge";
	stateTransitionOnTimeout[4]     = "Ready";
	stateTimeoutValue[4]            = 5;
	stateAllowImageChange[4]        = true;
	stateWaitForTimeout[4]			= true;
//	stateSequence[4]                = "StopFire";
	stateScript[4]                  = "onRechargeFire";

};


function FireFlyFlashImage::onPreFire(%this,%obj,%slot)
{
	if(!isObject(%obj) || %obj.getState() $= "Dead" || (%obj.lastFireTime+%this.minShotTime) > getSimTime())
		return;
	%pos = %obj.getPosition();
	%flashPosition = VectorAdd(getWords(%obj.getSlotTransform(4),0,2), %pos);
	%obj.playthread(2, activate);
//	%obj.lastFireTime = getSimTime();
	%scaleFactor = getWord(%obj.getScale(), 2);
    %p = new Projectile()
    {
		dataBlock = %this.projectile;
        initialPosition = %flashPosition;
        initialVelocity = 0;
        sourceObject = %obj;
        client = %obj.client;
        sourceSlot = 0;
        originPoint = %pos;
    };
    MissionCleanup.add(%p);
    %p.setScale(%scaleFactor SPC %scaleFactor SPC %scaleFactor);
    %p.explode();
}

function FireFlyFlashImage::onFire(%this,%obj,%slot)
{
	if(!isObject(%obj) || %obj.getState() $= "Dead" || (%obj.lastFireTime+%this.minShotTime) > getSimTime())
		return;
	%pos = %obj.getPosition();
	%flashPosition = VectorAdd(getWords(%obj.getSlotTransform(4),0,2), %pos);
//	%obj.playthread(2, activate);
	%obj.lastFireTime = getSimTime();
//	%scaleFactor = getWord(%obj.getScale(), 2);
//    %p = new Projectile()
//    {
//		dataBlock = %this.projectile;
//        initialPosition = %flashPosition;
//        initialVelocity = 0;
//        sourceObject = %obj;
//        client = %obj.client;
//        sourceSlot = 0;
//        originPoint = %pos;
//    };
//    MissionCleanup.add(%p);
//    %p.setScale(%scaleFactor SPC %scaleFactor SPC %scaleFactor);
//    %p.explode();

	//Let's search for those who are nearby the firefly.
	%range = 10; //Range of check	//10
	%searchMasks = $TypeMasks::PlayerObjectType;
	InitContainerRadiusSearch(%pos, %range, $Typemasks::PlayerObjectType);
	while(%hit = ContainerSearchNext())
	{
		//In this while-loop, everyone who is nearby will pass the following tests:
		if(%hit != %obj && minigameCanDamage(%obj, %hit) && %hit.getState() !$= "Dead")
		{
			if(%hit.getDatablock().flashImmune != 1)	//flashImmune 1 people are no fun, resisting flashes and all. :C
			{
				%object = ContainerRayCast(%flashPosition, %hit.getEyePoint(), $TypeMasks::FxBrickObjectType | $TypeMasks::PlayerObjectType | $TypeMasks::VehicleObjectType, %hit);
				%obstr = getWord(%object,0);
				if(!isObject(%obstr)) //Nothing obstructing the sight between the target and the firefly?
				{
					//Needed to determine exactly in what direction the player is looking.
					%start = %obj.getMuzzlePoint(%slot);
					//DONT TOUCH ANYTHING BETWEEN THIS LINE...
					%fvec = %hit.getForwardVector();
					%fX = getWord(%fvec,0);
					%fY = getWord(%fvec,1);
					%evec = %hit.getEyeVector();
					%eX = getWord(%evec,0);
					%eY = getWord(%evec,1);
					%eZ = getWord(%evec,2);
					%eXY = mSqrt(%eX*%eX+%eY*%eY);
					%aimVec = %fX*%eXY SPC %fY*%eXY SPC %eZ;
					//...AND THIS LINE, THE LINE ABOVE THESE AND THE LINE BELOW THESE ARE FOR STARTING POINT AND ENDING POINT RESPECTIVELY
					%end = %hit.getHackPosition();
					%dir = vectorNormalize(vectorSub(%start,%end)); //Better not touch this either.
					if(vectorDot(%aimVec, %dir) >= -0.25) //Angle check (lower value means closer to middle, -1 being the lowest value you should take (perfect middle), anything above 0 is actually like behind him)		//-0.2
					{
						//Target is looking at firefly, for sure.
						%whiteOutAmnt = 1.6; //Basic amount of flash to be given	//50
						%damageAmnt = 36; //Basic amount of damage to be given		//16
						if(%hit.getDatablock().flashImmune == 2) //People with flashImmune 2 are no fun, cutting down the amounts to a half and shit.
						{
							%whiteOutAmnt = %whiteOutAmnt / 2;
							%damageAmnt = %damageAmnt / 2;
						}
						if(%hit.getclassname() $= "Player") //Only real players can be whiteout'd.
						{
							if(%hit.getWhiteout() < %whiteOutAmnt)
								%hit.setWhiteout(%whiteOutAmnt); //Sets the flashAmount given above if the amount of flashyness on the target is lower then the amount.
						}
						%hit.damage(%obj,%hit.getPosition(), %damageAmnt, $DamageType::Generic); //DAMAGE
						//Replace "$DamageType::Generic" with your own damageType if you ahve created one (just like you would fill in the directDamageType in a projectile (for example))
					}
				}
			}
		}
	}
}
