//Weapon_Gls_Slash.cs


datablock ExplosionData(MantisSlashExplosion)
{
   explosionShape = "base/data/shapes/empty.dts";
   lifeTimeMS = 200;	//500

   soundProfile = swordHitSound;

   particleEmitter = MantisSlashHitEmitter;
   particleDensity = 12;
   particleRadius = 0.01;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "1.0 1.0 1.0";
   camShakeAmp = "30.0 20.0 8.0";
   camShakeDuration = 0.1;
   camShakeRadius = 5.0;

//   	impulseRadius = 2;
//	impulseForce = 0;

//	damageRadius = 2;
//	radiusDamage = 5;

};


//projectile
//AddDamageType("Mitebite",   '<bitmap:add-ons/Weapon_Sword/CI_sword> %1',    '%2 <bitmap:add-ons/Weapon_Sword/CI_sword> %1',0.75,1);
datablock ProjectileData(MantisSlashProjectile) // : BugBitePtojectile)
{
   directDamage        = 20;	//20	//20
//   directDamageType  = $DamageType::Mitebite;
//   radiusDamageType  = $DamageType::Mitebite;
   explosion           = MantisSlashExplosion;

	impactImpulse	   = 0;
	verticalImpulse	   = 0;

   muzzleVelocity      = 100;	//80
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 100;
   fadeDelay           = 70;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0.0;

//   hasLight    = false;
//   lightRadius = 3.0;
//   lightColor  = "0 0 0.5";

   uiName = "Mantis Slash";
};


//////////
// item //
//////////
datablock ItemData(MantisSlashItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	// Basic Item Properties
	shapeFile = "base/data/shapes/empty.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = false;

	//gui stuff
	uiName = "Mantis Slash";
	iconName = "./Icon_MantisSlash";
//	doColorShift = false;
//	colorShiftColor = "0.471 0.471 0.471 1.000";

	// Dynamic properties defined by the scripts
	image = MantisSlashImage;
	canDrop = false;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(MantisSlashImage)
{
   // Basic Item properties
	shapeFile = "base/data/shapes/empty.dts";
	emap = false;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   eyeOffset = "0 0 0";

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = MantisSlashProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = true;
   doRetraction = false;
   //raise your arm up or not
   armReady = false;

   //casing = " ";
//   doColorShift = false;
//   colorShiftColor = "0.471 0.471 0.471 1.000";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.1;
	stateTransitionOnTimeout[0]      = "Ready";
//	stateSound[0]                    = swordDrawSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Recharge";
	stateTimeoutValue[2]            = 0.6;		//0.38
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
//	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]		= true;

//	stateName[4]			= "CheckFire";
//	stateTransitionOnTriggerUp[4]	= "StopFire";
//	stateTransitionOnTriggerDown[4]	= "Fire";
	
	stateName[3]                    = "Recharge";
//	stateTransitionOnTimeout[3]     = "Ready";
//	stateTimeoutValue[3]            = 0.25;
	stateAllowImageChange[3]        = true;
//	stateWaitForTimeout[3]			= true;
//	stateSequence[3]                = "StopFire";
//	stateScript[3]                  = "onStopFire";
	stateTransitionOnTriggerUp[3]	= "Ready";

};

function MantisSlashImage::onFire(%this, %obj, %slot)
{
//	if(getRandom(0,1))
//	{
//		%obj.playthread(2, plant);
//	}
//	else 
	if(getRandom(0,1))
	{
		%obj.playthread(2, shiftLeft);
	}
	else
	{
		%obj.playthread(2, shiftRight);
	}
	Parent::onFire(%this,%obj,%slot);
}
